/*
// 2007-05-21
// Copyright (c) Art. Lebedev | http://www.artlebedev.ru/
// Author - Vladimir Tokmakov
*/

function ecProcess_XML( sURL, ptrFunction ){
	var oXML;
	try{
		// if MSIE
		oXML = new ActiveXObject( "Microsoft.XMLDOM" );
		oXML.async = false;
		oXML.load( sURL );
		ptrFunction( oXML.documentElement );
		return true;
	}catch( error ){
		try{
			// if Mozzila
			oXML = new XMLHttpRequest();
			oXML.open( "GET", sURL, false );
			oXML.setRequestHeader( "If-Modified-Since", "Thu, 22 Nov 2001 00:00:01 GMT" );
			oXML.send( null );
			ptrFunction( oXML.responseXML.documentElement );
			return true;
		}catch( error ){
			if( document.appendChild ){
				// if Chimera, Opera in future...
				// modified by Leechy - 13.11.2002
				var eIFRAME = ecMake_IFRAME( "", sURL );
				eIFRAME.style.width = "1px";
				eIFRAME.style.height = "1px";
				eIFRAME.style.position = "absolute";
				eIFRAME.style.visibility = "hidden";
				eIFRAME.onload = function(){
					ptrFunction( this.contentDocument );
				}
			}
			return false;
		}
	}
}

function ecMake_IFRAME( sID, sURL, sContent, eWhere, ptrAfter ){
	var eDIV = document.createElement( "DIV" );
	eDIV.innerHTML = '<iframe frameborder="no"></iframe>';
	var eIFRAME = eDIV.firstChild;
	if( sID ){
		eIFRAME.setAttribute( "id", sID );
	}
	if( eWhere ){
		eWhere.appendChild( eIFRAME );
	}else{
		document.body.appendChild( eIFRAME );
	}
	if( sContent ){
		if( eIFRAME.contentWindow && eIFRAME.contentWindow.document ){
				eIFRAME.contentWindow.document.open();
				eIFRAME.contentWindow.document.write( sContent );
				eIFRAME.contentWindow.document.close();
				if( ptrAfter ){
					ptrAfter();
				}
		}else{
			eIFRAME.onload = function(){
				if( eIFRAME.document ){
					eIFRAME.document.open();
					eIFRAME.document.write( sContent );
					eIFRAME.document.close();
				}
				eIFRAME.onload = null;
				if( ptrAfter ){
					ptrAfter();
				}
			}
		}
	}else if( sURL != "" ){
		eIFRAME.src = sURL;
	}
	return eIFRAME;
}

var ec_asScript_URL = new Array();
var ec_asScript_variable = new Array();
var ec_aiScript_attempt = new Array();
var ec_iScript_timeout = 60000;
var ec_iTimeout_interval = 100;

function ecRun_on_load_external_scripts( ptrFunction ){
	var iThread = ec_aiScript_attempt.length;
	ec_aiScript_attempt[iThread] = 0;
	ecRun_on_load_external_scripts_cyclic( ptrFunction, iThread );
}

function ecLoad_external_script( sURL, sVariable_name, sCharset ){
	if( !ecExternal_script_loaded( sURL ) ){
		var eScript = document.createElement( "SCRIPT" );
		eScript.setAttribute( "type", "text/javascript" );
		//eScript.setAttribute( "charset", sCharset );
		eScript.setAttribute( "src", sURL );
		document.body.appendChild( eScript );
		ec_asScript_URL[ec_asScript_URL.length] = sURL;
		ec_asScript_variable[ec_asScript_variable.length] = sVariable_name;
	}
}

function ecExternal_script_loaded( sURL ){
	for( var i = 0 ; i < ec_asScript_URL.length ; i++ ){
		if( ec_asScript_URL[i] == sURL ){
			return true;
		}
	}
	return false;
}

function ecRun_on_load_external_scripts_cyclic( ptrFunction, iThread ){
	var iScript_variable_length = ec_asScript_variable.length;
	for( var i = 0 ; i < ec_asScript_variable.length ; i++ ){
		if( window[ec_asScript_variable[i]] ){
			ec_asScript_variable[i] = false;
		}
		if( !ec_asScript_variable[i] ){
			iScript_variable_length--;
		}
	}
	if( iScript_variable_length == 0 ){
		ptrFunction();
//		window.status = ""
	}else{
		if( ec_iTimeout_interval * ec_aiScript_attempt[iThread] < ec_iScript_timeout ){
			ec_aiScript_attempt[iThread]++;
			if( cmn_oInformation.bIE && !document.location.href.match( /https?\:\/\// ) ){
				ptrFunction();
			}else{
//				window.status = "loading external scripts - " + ( ec_iScript_timeout - ec_iTimeout_interval * ec_aiScript_attempt[iThread] ) / 1000
				setTimeout( "ecRun_on_load_external_scripts_cyclic(" + ptrFunction + "," + iThread + ")", ec_iTimeout_interval );
			}
		}else{
			alert( "Error: Scripts loading error!" );
		}
	}
}

